//+------------------------------------------------------------------+
//| Uses cloned BBs calculated by Indicator.        Greedy Bands.mq4 |
//| Last edit: July 22, 2014                                         |
//| The leading -3 Back shifted BB is Greedy.                        |
//| It "snags" price outliers at levels that can set-up apparent S/R.|
//| Strange when not associated with normal S/R such as Hi/Lo, TLs.  |
//| Much like the BBs, things will sometimes click and sometimes not.|
//| Yeah! This indicator if for investigation only and not suitable  |
//| for purpose of trade! Nobody knows what it does anyway ;-)       |
//+------------------------------------------------------------------+
#property copyright " 2014 apipshort"
#property link "http://www.forexfactory.com/showthread.php?t=494596"
#property indicator_chart_window

#property indicator_buffers 7
#property indicator_color1 SandyBrown
#property indicator_color2 SandyBrown
#property indicator_color3 SandyBrown
#property indicator_color4 DeepSkyBlue
#property indicator_color5 DeepSkyBlue
#property indicator_color6 MediumVioletRed
#property indicator_color7 MediumVioletRed

extern string       Make_Sure = "     Set SMA Period equal to BB system!";
extern string      SMA_Period = "     Default Simple MA Period = 25";
extern int          smaPeriod = 25;    // 20 - 25 ... ??
extern string  SetDeviationAt = "     Any Positive Double";
extern double       useStdDev = 2.0;   // 2.0 // PI = 3.14159265
extern string         Setting = "     More Options";
extern bool      onlyNormalBB = false; // if true show only a normal BB
extern int           barLimit = 0;     // 0 = use all bars possible
extern bool           showRay = false; // false
extern bool       showComment = true;  // true
extern bool       showPiLines = true;  // true
extern string         Control = "     Colors";
extern string BackGroundColor = "     Keep Colors = 0, Dark Screen = 1, Light = 2";
extern int            colorBG = 2;     // 1 or 2
extern color         colorSMA = SandyBrown;      // SandyBrown
extern color        Normal_BB = SandyBrown;      // SandyBrown
extern color        Greedy_BB = DeepSkyBlue;     // DeepSkyBlue, Aqua on dark BG
extern color          Last_BB = MediumVioletRed; // MediumVioletRed
extern int              width = 0;     //0

string pref = "greedy_";
int    maxBars, hitHi, hitLo; // testable bars, hi/lo hit counters
color  clrHiLine = Red, clrLoLine = Green;  // PI Line colors
bool   allDone = false;       // flag work done

//buffers
double sma[];
double hiNormal[], loNormal[]; // shift = 0
double hiLast[],   loLast[];   // shift = +3
double hiGreedy[], loGreedy[]; // shift = -3

//+------------------------------------------------------------------+

void SetColors(int backGround)
   {
   switch (backGround)
      {
      case 0: break; //keep actual user Colors unchanged
      case 1: colorSMA = SandyBrown; Normal_BB = SandyBrown; Greedy_BB = Aqua; Last_BB = MediumVioletRed; clrHiLine = Red; clrLoLine = Lime; return;
      case 2: colorSMA = SandyBrown; Normal_BB = SandyBrown; Greedy_BB = DeepSkyBlue; Last_BB = MediumVioletRed; clrHiLine = Red; clrLoLine = Green; return;

      default:     return;

      return;
      }
   } // end void SetColors(int backGround)

//+------------------------------------------------------------------+

int init()
   {// discount labels code below:
   //if found label "00z_Mark" read SMA Period from there
   int getSMA = StrToInteger(ObjectDescription("00z_Mark"));
   if(getSMA > 2) smaPeriod = getSMA;

   //if found label "bg_Mark" read BG selection from there
   int getBG = StrToInteger(ObjectDescription("bg_Mark"));
   if(getBG > 0) colorBG = getBG;
   if(colorBG < 0 || colorBG > 2) colorBG = 0;
   SetColors(colorBG);

   maxBars = Bars - smaPeriod - 5; // add margin for +3 testing
   if(barLimit == 0 || barLimit > maxBars) barLimit = maxBars;
   maxBars = barLimit; // after checking for allowable barLimit

   useStdDev = MathAbs(useStdDev);

   string name = StringConcatenate("Greedy SMA ", smaPeriod);
   IndicatorShortName(name);

   SetIndexBuffer(0,sma);
   SetIndexStyle (0,DRAW_SECTION,STYLE_SOLID, width,colorSMA);
   SetIndexLabel (0,name);

   SetIndexBuffer(1,hiNormal);
   SetIndexStyle (1,DRAW_SECTION,STYLE_SOLID,width,Normal_BB);
   SetIndexLabel (1,"Upper BB");

   SetIndexBuffer(2,loNormal);
   SetIndexStyle (2,DRAW_SECTION,STYLE_SOLID,width,Normal_BB);
   SetIndexLabel (2,"Lower BB");

   SetIndexBuffer(3,hiGreedy);
   SetIndexStyle (3,DRAW_SECTION,STYLE_SOLID,width,Greedy_BB);
    SetIndexShift(3, -3);
   SetIndexLabel (3,"greedy_hi");

   SetIndexBuffer(4,loGreedy);
   SetIndexStyle (4,DRAW_SECTION,STYLE_SOLID,width,Greedy_BB);
    SetIndexShift(4, -3);
   SetIndexLabel (4,"greedy_lo");

   SetIndexBuffer(5,hiLast);
   SetIndexStyle (5,DRAW_SECTION,STYLE_SOLID,width,Last_BB);
    SetIndexShift(5, 3);
   SetIndexLabel (5,"trailing_hi");

   SetIndexBuffer(6,loLast);
   SetIndexStyle (6,DRAW_SECTION,STYLE_SOLID,width,Last_BB);
    SetIndexShift(6, 3);
   SetIndexLabel (6,"trailing_lo");

   return(0);
   } // end int init()

//+------------------------------------------------------------------+

int deinit()
   {
   Clear(pref, 0);
   if(showComment) Comment("");

   return(0);
   } // end int deinit()

//+------------------------------------------------------------------+

int start()
   {
   if(allDone) barLimit = 10;
   for(int i = barLimit; i>=0; i--)
      {
      sma[i] = iMA(NULL, 0, smaPeriod, 0, MODE_SMA,PRICE_CLOSE, i);
      hiNormal[i] = iBands(NULL, 0, smaPeriod, useStdDev, 0, PRICE_CLOSE,MODE_UPPER, i);
      loNormal[i] = iBands(NULL, 0, smaPeriod, useStdDev, 0, PRICE_CLOSE,MODE_LOWER, i);

      if(!onlyNormalBB)
         {
         hiGreedy[i] = hiLast[i] = hiNormal[i];
         loGreedy[i] = loLast[i] = loNormal[i];
         }

      if(showPiLines && !onlyNormalBB) SetPI(i);
      } //end for(int i = barLimit

   allDone = true;
   if(allDone && showComment)
      {
      double count = hitHi + hitLo;
      string percHits = DoubleToString((count/maxBars)*100, 2);
      Comment("Total Bars ", Bars, "  Bars Tested ", maxBars,  "  Bars Hit ", count,
              "  High Lines ", hitHi, "  Low Lines ", hitLo, "  Hits = ", percHits, " %");
      } // end if(allDone && showComment)

   return(0);
   } // end start()

//+------------------------------------------------------------------+

void SetPI(int i)
   {
   int k = i; // need to keep updating first 10 bars to draw completed PI lines
   if(i <= 10) k = 10;
   double hi = iHigh(NULL,0, i+3); // testing high & low of +3 signal bar
   double lo =  iLow(NULL,0, i+3);

   if(hi > hiGreedy[i] && GetZHi(0, i+3) > 2.0) // high hit, false hits filtered
      {
      TrendLine("PI_hi "+i,  i+4, k-10, hiGreedy[i], hiGreedy[i], clrHiLine, 0, 0, showRay, false);
      TrendLine("bar_hi "+i, i+4, i, hi, hi, Red, 2, 0, false, false);
      if(!allDone) hitHi++;
      }

   if(lo < loGreedy[i] && GetZLo(0, i+3) < -2.0) // low hit, false hits filtered
      {
      TrendLine("PI_lo "+i,  i+4, k-10, loGreedy[i], loGreedy[i], clrLoLine, 0, 0, showRay, false);
      TrendLine("bar_lo "+i, i+4, i, lo, lo, Green, 2, 0, false, false);
      if(!allDone) hitLo++;
      }

   return;
   } // end void SetPI(int i)

//+---------------------------SUPPORT--------------------------------+

void TrendLine(string obj, int t1, int t2, double p1, double p2, color clr, int st, int w, bool ray, bool back)
   {
   obj = StringConcatenate(pref, obj);
   if(!ObjectCreate(obj, OBJ_TREND, 0,0,0,0,0))  ObjectCreate(obj, OBJ_TREND, 0,0,0,0,0);
      if(!ObjectSet(obj, OBJPROP_TIME1, Time[t1])) ObjectSet(obj, OBJPROP_TIME1, Time[t1]);
      if(!ObjectSet(obj, OBJPROP_TIME2, Time[t2])) ObjectSet(obj, OBJPROP_TIME2, Time[t2]);
      if(!ObjectSet(obj, OBJPROP_PRICE1, p1))      ObjectSet(obj, OBJPROP_PRICE1, p1);
      if(!ObjectSet(obj, OBJPROP_PRICE2, p2))      ObjectSet(obj, OBJPROP_PRICE2, p2);
      if(!ObjectSet(obj, OBJPROP_COLOR,  clr))     ObjectSet(obj, OBJPROP_COLOR,  clr);
      if(!ObjectSet(obj, OBJPROP_STYLE,  st))      ObjectSet(obj, OBJPROP_STYLE,  st);
      if(!ObjectSet(obj, OBJPROP_WIDTH,  w))       ObjectSet(obj, OBJPROP_WIDTH,  w);
      if(!ObjectSet(obj, OBJPROP_RAY,    ray))     ObjectSet(obj, OBJPROP_RAY,    ray);
      if(!ObjectSet(obj, OBJPROP_BACK,   back))    ObjectSet(obj, OBJPROP_BACK,   back);

   return;
   }// end void TrendLine(

//+------------------------------------------------------------------+

void Clear(string findMe, int startFrom)
   {
   string name;
   int obj_total = ObjectsTotal();
   for (int i=obj_total-1; i>=0; i--)
      {
       name = ObjectName(i);
       if (StringFind(name, findMe) == startFrom) ObjectDelete(name);
      }
   return;
   } // end void Clear(

//+------------------------------------------------------------------+

double GetZHi(int per, int bar)
   { // Bar High z-score
   return((iHigh(NULL, per, bar) -
             iMA(NULL, per, smaPeriod, 0,MODE_SMA,PRICE_CLOSE, bar))/
         iStdDev(NULL, per, smaPeriod, 0,MODE_SMA,PRICE_CLOSE, bar));
   } // end double GetZHi(int per, int bar)

//+------------------------------------------------------------------+

double GetZLo(int per, int bar)
   { // Bar Low z-score
   return((iLow(NULL, per, bar) -
            iMA(NULL, per, smaPeriod, 0,MODE_SMA,PRICE_CLOSE, bar))/
        iStdDev(NULL, per, smaPeriod, 0,MODE_SMA,PRICE_CLOSE, bar));
   } // end double GetZLo(int per, int bar)

//+-----------------------------EOP----------------------------------+
